#cloud-config
timezone: "${timezone}"
groups:
  - docker
users:
  - name: gitlab-runner
    groups: docker
apt:
  sources:
    docker.list:
      source: 'deb [arch=amd64] https://download.docker.com/linux/ubuntu $RELEASE stable'
      keyid: 0EBFCD88
    gitlab.list:
      source: 'deb https://packages.gitlab.com/runner/gitlab-runner/ubuntu/ $RELEASE main'
      keyid: F640 3F65 44A3 8863 DAA0 B6E0 3F01 618A 5131 2F3F # key seems to be valid till 2024-03-01

package_upgrade: true
package_update: true

packages:
  - debian-archive-keyring
  - apt-transport-https
  - ca-certificates
  - software-properties-common
  - htop
  - docker-ce
  - golang-go
  - gitlab-runner=${runner-version}
  - fail2ban
  - vim

write_files:
  - content: |
      Explanation: Prefer GitLab provided packages over the Debian native ones
      Package: gitlab-runner
      Pin: origin packages.gitlab.com
      Pin-Priority: 1001
    path: /etc/apt/preferences.d/pin-gitlab-runner.pref
  - owner: root:root
    path: /etc/cron.d/your_cronjob
    content: "* 5 * * * root (/usr/bin/docker ps --filter status=dead --filter status=exited -aq   |  /usr/bin/xargs /usr/bin/docker rm -v 2> /dev/null) || true"
  - owner: root:root
    path: /root/register.sh
    content: |
      gitlab-runner register --executor docker  \
        -u ${gitlab_url} \
        --run-untagged=${run-untagged} \
        --tag-list "${join(",", tags)}" \
        --locked=false \
        --non-interactive \
        -r ${token} \
        --docker-privileged=${privileged} \
        --docker-pull-policy=if-not-present \
        --docker-shm-size=268435456 \
        --docker-image="${default-image}" \
        --docker-volumes='/cache'
runcmd:
  - [/bin/bash, /root/register.sh]

power_state:
  delay: "now"
  mode: reboot
  message: First reboot
  condition: True
